Bug 252687 - Making graphics/opensubdiv depend on onetbb
Summary: Making graphics/opensubdiv depend on onetbb
Status: Closed FIXED
Alias: None
Product: Ports & Packages
Classification: Unclassified
Component: Individual Port(s) (show other bugs)
Version: Latest
Hardware: Any Any
: --- Affects Some People
Assignee: Ganael LAPLANCHE
URL:
Keywords:
Depends on:
Blocks: 252648 252868
  Show dependency treegraph
 
Reported: 2021-01-14 21:40 UTC by Ganael LAPLANCHE
Modified: 2021-01-31 16:55 UTC (History)
1 user (show)

See Also:
FreeBSD: maintainer-feedback+
FreeBSD: maintainer-feedback+


Attachments
maintainer update for graphics/opensubdiv (765 bytes, patch)
2021-01-19 04:12 UTC, Shane
FreeBSD: maintainer-approval+
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Ganael LAPLANCHE freebsd_committer 2021-01-14 21:40:42 UTC
Hello,

As a maintainer of graphics/opensubdiv, could you have a look at PR #252648:

  https://bugs.freebsd.org/bugzilla/show_bug.cgi?id=252648

In short, TBB version 2021 will soon be available as devel/onetbb but the port you maintain does not build correctly with it, see the following Poudriere run:

  http://box.martymac.org/FreeBSD-Packages/build.html?mastername=FBSD122amd64-tbb-migr&build=2021-01-13_22h35m17s

and error logs:

http://box.martymac.org/FreeBSD-Packages/data/FBSD122amd64-tbb-migr/2021-01-13_22h35m17s/logs/errors/opensubdiv-3.4.3_2.log

/usr/bin/c++ -DGLFW_VERSION_3 -DOPENSUBDIV_HAS_GLSL_COMPUTE -DOPENSUBDIV_HAS_GLSL_TRANSFORM_FEEDBACK -DOPENSUBDIV_HAS_OPENGL -DOPENSUBDIV_HAS_TBB -DOPENSUBDIV_VERSION_STRING=\"3.4.3\" -DOSD_USES_INTERNAL_GLAPILOADER -I/wrkdirs/usr/ports/graphics/opensubdiv/work/OpenSubdiv-3_4_3/opensubdiv -I/usr/local/include -I/wrkdirs/usr/ports/graphics/opensubdiv/work/OpenSubdiv-3_4_3/glLoader -Iopensubdiv/osd -O2 -pipe -fstack-protector-strong -fno-strict-aliasing  -O2 -pipe -fstack-protector-strong -fno-strict-aliasing   -Wall -Wextra -Wno-invalid-offsetof -Wno-strict-aliasing -Wno-overloaded-virtual -fPIC -MD -MT opensubdiv/osd/CMakeFiles/osd_cpu_obj.dir/tbbEvaluator.cpp.o -MF opensubdiv/osd/CMakeFiles/osd_cpu_obj.dir/tbbEvaluator.cpp.o.d -o opensubdiv/osd/CMakeFiles/osd_cpu_obj.dir/tbbEvaluator.cpp.o -c /wrkdirs/usr/ports/graphics/opensubdiv/work/OpenSubdiv-3_4_3/opensubdiv/osd/tbbEvaluator.cpp
/wrkdirs/usr/ports/graphics/opensubdiv/work/OpenSubdiv-3_4_3/opensubdiv/osd/tbbEvaluator.cpp:28:10: fatal error: 'tbb/task_scheduler_init.h' file not found
#include <tbb/task_scheduler_init.h>
         ^~~~~~~~~~~~~~~~~~~~~~~~~~~
1 error generated.

Could you try to provide a patch (important: *by replying to this PR*) to facilitate the migration to devel/onetbb ?

To help you modifying your port, expected patches to devel/tbb and devel/onetbb are available in PR #252648.

Thanks for your contribution,
Best regards,

Ganael.
Comment 1 Shane 2021-01-19 04:12:57 UTC
Created attachment 221724 [details]
maintainer update for graphics/opensubdiv

I'm going with disabling tbb until upstream ports to the new api.
Comment 2 Ganael LAPLANCHE freebsd_committer 2021-01-19 11:05:44 UTC
Hello Shane,

OK, thanks, I'll keep that patch for the big switch.

Opensubdiv is currently a default dependency of Blender, we'll probably have to disable it by default, then. I'll submit that with a dedicated PR for Blender (which also directly depends on tbb).

Best regards,

Ganael.
Comment 3 Shane 2021-01-20 01:09:55 UTC
(In reply to Ganael LAPLANCHE from comment #2)
opensubdiv can still be used without tbb, so it can be disabled before the switch. Blender can use opensubdiv with tbb disabled.

I'm also the maintainer for blender. I'm starting to think that being able to co-install the old tbb will need to be an option for a while.

For blender, disabling tbb means disabling openvdb, openimagedenoise, mod_fluids and cycles. While the first two can be disabled for a while, I doubt anyone will want blender without cycles. Blender is setup to disable those four options if using tbb is disabled and cycles doesn't compile without tbb.
Comment 4 commit-hook freebsd_committer 2021-01-20 20:40:00 UTC
A commit references this bug:

Author: martymac
Date: Wed Jan 20 20:39:22 UTC 2021
New revision: 562158
URL: https://svnweb.freebsd.org/changeset/ports/562158

Log:
  Disable TBB by default before oneTbb transition

  PR:		252687
  Submitted by:	FreeBSD@ShaneWare.Biz
  Approved by:	FreeBSD@ShaneWare.Biz (maintainer)

Changes:
  head/graphics/opensubdiv/Makefile
Comment 5 Ganael LAPLANCHE freebsd_committer 2021-01-20 20:45:58 UTC
(In reply to Shane from comment #3)

Hello Shane,

I have committed the patch, thanks.

Regarding Blender, I'll now open a dedicated PR for it. Let's switch the discussion into that one.

I'll leave that PR open hoping for an update from upstream allowing the use of oneTBB (to be able to really switch to it once possible).

Best regards,

Ganael.
Comment 6 Ganael LAPLANCHE freebsd_committer 2021-01-20 20:59:13 UTC
PR open: https://bugs.freebsd.org/bugzilla/show_bug.cgi?id=252868